*//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*// Author:  Michael Drozdov, ICS Soft, Perm, Russia 
*// My Page: http://vfpdev.narod.ru/ 
*// Date:    10/17/2005
*//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#DEFINE USE_TRY_CATCH	.F.
#DEFINE ERR_PREFIX		" #| "

#DEFINE USE_OUTPUT_FILE	.F.
#DEFINE OUTPUT_FILE		"C:\Temp\temp.xml"

#DEFINE CURSORTOXML_FLG	 4+32

#DEFINE LANG_RUS_LOC	.T.
#IF LANG_RUS_LOC
	#DEFINE ERR_CODE_LOC			" : "
	#DEFINE ERR_DESCRIPT_LOC		": "
	#DEFINE ERR_SOURCE_LOC			": "
	#DEFINE ERR_METHOD_LOC			" : "
	#DEFINE ERR_LINE_LOC			" : "
	#DEFINE ERR_CLASS_LOC			" : "
	#DEFINE ERR_LIB_LOC				" : "
#ELSE
	#DEFINE ERR_CODE_LOC			"Error number: "
	#DEFINE ERR_DESCRIPT_LOC		"Description: "
	#DEFINE ERR_SOURCE_LOC			"Source: "
	#DEFINE ERR_METHOD_LOC			" Method: "
	#DEFINE ERR_LINE_LOC			" Line: "
	#DEFINE ERR_CLASS_LOC			" Class: "
	#DEFINE ERR_LIB_LOC				" Library: "
#ENDIF

#DEFINE CRLF			CHR(13) + CHR(10)
#DEFINE ERR_CHRSEP		", "

*////////////////////////////////
*// class: testvfp
*//
DEFINE CLASS testvfp As Session OLEPUBLIC

	*////////////////////////////////
	*// Error()
	PROCEDURE Error(nError, cMethod, nLine)
		LOCAL ARRAY laErr[1]
		=AERROR(laErr)
		LOCAL lcExceptionSource as String
		lcExceptionSource = ''
		IF !EMPTY(cMethod)
			lcExceptionSource = lcExceptionSource + ERR_METHOD_LOC + cMethod
		ENDIF
		IF !EMPTY(nLine)
			lcExceptionSource = lcExceptionSource + ERR_CHRSEP + ERR_LINE_LOC + LTRIM(TRANSFORM(nLine))
		ENDIF
		IF !EMPTY(this.Class)
			lcExceptionSource = lcExceptionSource + ERR_CHRSEP + ERR_CLASS_LOC + this.Class
		ENDIF
		IF !EMPTY(this.ClassLibrary)
			lcExceptionSource = lcExceptionSource + ERR_CHRSEP + ERR_LIB_LOC + this.ClassLibrary
		ENDIF
		CLOSE TABLES ALL 
		IF !INLIST(Application.StartMode, 0, 4) 
			COMRETURNERROR(lcExceptionSource, laErr[2])
		ELSE
			LOCAL lcErrMsg as String
			lcErrMsg = ''
			IF !EMPTY(laErr[1])
				lcErrMsg = ERR_CODE_LOC + LTRIM(TRANSFORM(nLine))
			ENDIF
			IF !EMPTY(laErr[2])
				lcErrMsg = lcErrMsg + CRLF + ERR_DESCRIPT_LOC + laErr[2]
			ENDIF
			IF !EMPTY(lcExceptionSource)
				lcErrMsg = lcErrMsg + CRLF + ERR_SOURCE_LOC + lcExceptionSource
			ENDIF
			= MESSAGEBOX(lcErrMsg, 16, _SCREEN.Caption) 
		ENDIF	
	ENDPROC	

	*////////////////////////////////
	*// TestTypes()
	FUNCTION TestTypes(tBool as Boolean, tByte as Byte;
			,tCharacter as Character, tCurrency as Currency;
			,tDatetime as Datetime, tDecimal as Decimal;
			,tDouble as Double, tInteger as Integer;
			,tLogical as Logical, tLong as Long;
			,tNumber as Number, tShort as Short;
			,tSingle as Single, tString as String;
			,tVariant as Variant) as String 
		LOCAL lcRetVal as String;
			,loException as Exception
		lcRetVal = '' 
#IF USE_TRY_CATCH
		TRY	
#ENDIF
		lcRetVal = lcRetVal + "tBool["+TYPE('tBool')+"] = " + IIF(tBool, '.T.', '.F.')+ ", "
		lcRetVal = lcRetVal + "tByte["+TYPE('tByte')+"] = " + LTRIM(TRANSFORM(tByte))+ ", "
		lcRetVal = lcRetVal + "tCharacter["+TYPE('tCharacter')+"] = " + tCharacter + ", "
		lcRetVal = lcRetVal + "tCurrency["+TYPE('tCurrency')+"] = " + LTRIM(TRANSFORM(tCurrency, '@C')) + ", "
		lcRetVal = lcRetVal + "tDatetime["+TYPE('tDatetime')+"] = " + TRANSFORM(tDatetime, '@E') + ", "
		lcRetVal = lcRetVal + "tDecimal["+TYPE('tDecimal')+"] = " + TRANSFORM(tDecimal, '@^') + ", "
		lcRetVal = lcRetVal + "tDouble["+TYPE('tDouble')+"] = " + TRANSFORM(tDouble, '@^') + ", "
		lcRetVal = lcRetVal + "tInteger["+TYPE('tInteger')+"] = " + LTRIM(TRANSFORM(tInteger)) + ", "
		lcRetVal = lcRetVal + "tLogical["+TYPE('tLogical')+"] = " + IIF(tLogical, '.T.', '.F.')+ ", "
		lcRetVal = lcRetVal + "tLong["+TYPE('tLong')+"] = " + LTRIM(TRANSFORM(tLong)) + ", "
		lcRetVal = lcRetVal + "tNumber["+TYPE('tNumber')+"] = " + LTRIM(TRANSFORM(tNumber)) + ", "
		lcRetVal = lcRetVal + "tShort["+TYPE('tShort')+"] = " + LTRIM(TRANSFORM(tShort)) + ", "
		lcRetVal = lcRetVal + "tSingle["+TYPE('tSingle')+"] = " + LTRIM(TRANSFORM(tSingle)) + ", "
		lcRetVal = lcRetVal + "tString["+TYPE('tString')+"] = " + tString + ", "
		lcRetVal = lcRetVal + "tVariant["+TYPE('tVariant')+"] = " + TTOC(tVariant, 3)
#IF USE_TRY_CATCH
		CATCH TO loException
			IF loException.ErrorNo # 0
				lcRetVal = lcRetVal ;
					+ ERR_PREFIX + ERR_CODE_LOC + LTRIM(TRANSFORM(loException.ErrorNo)) ;
					+ ERR_CHRSEP+ ERR_DESCRIPT_LOC + loException.Message 
			ENDIF
		ENDTRY			 
#ENDIF
		RETURN lcRetVal
	ENDFUNC

	*////////////////////////////////
	*// LongRun()
	FUNCTION LongRun(tnTimeOutSec as Long) as Variant 
		LOCAL lnRetVal as Variant;
			,loException as Exception
		luRetVal = 0 
#IF USE_TRY_CATCH
		TRY	
#ENDIF
			IF VARTYPE(tnTimeOutSec) # 'N'
				tnTimeOutSec = 60
			ENDIF	
			LOCAL lnStart as Number
			lnStart = SECONDS()
			DO WHILE (SECONDS() - lnStart < tnTimeOutSec)
			ENDDO
			luRetVal = SECONDS() - lnStart 
#IF USE_TRY_CATCH
		CATCH TO loException
			IF loException.ErrorNo <> 0
				luRetVal = TRANSFORM(luRetVal) ;
					+ ERR_PREFIX + ERR_CODE_LOC + LTRIM(TRANSFORM(loException.ErrorNo)) ;
					+ ERR_CHRSEP+ ERR_DESCRIPT_LOC + loException.Message 
			ENDIF
		ENDTRY			 
#ENDIF
		RETURN luRetVal
	ENDFUNC

	*////////////////////////////////
	*// GetTable()
	FUNCTION GetTable(tcFile as String) as String 
		LOCAL m.lcRetVal as String;
			,m.loException as Exception;
			,m.lcAlias as String;
			,m.lcCursor as String;
			,m.lcExclus as String 
		m.loException = NULL
		STORE '' TO ;
			m.lcRetVal;
			,m.lcAlias;
			,m.lcCursor;
			,m.lcExclus
			IF SET("Exclusive") = 'ON'
				SET EXCLUSIVE OFF
				m.lcExclus = 'ON'
			ELSE
				m.lcExclus = 'OFF'
			ENDIF	
#IF USE_TRY_CATCH
		TRY	
#ENDIF
			m.lcAlias = JUSTSTEM(m.tcFile)
			m.lcCursor = "_" + m.lcAlias  
			SELECT * FROM (m.tcFile) INTO CURSOR (m.lcCursor)
			IF USED(m.lcCursor) AND _TALLY > 0
				LOCAL lnSize as Number 
				m.lnSize = CURSORTOXML(m.lcCursor, 'm.lcRetVal', 1, CURSORTOXML_FLG, 0, '1')
#IF USE_OUTPUT_FILE
				IF FILE(OUTPUT_FILE)
					ERASE (OUTPUT_FILE)
				ENDIF
				STRTOFILE(m.lcRetVal, OUTPUT_FILE, 4)	
#ENDIF

			ENDIF
#IF USE_TRY_CATCH
		CATCH TO m.loException
			IF m.loException.ErrorNo # 0
				m.lcRetVal =  ;
					+ ERR_PREFIX + ERR_CODE_LOC + LTRIM(TRANSFORM(loException.ErrorNo)) ;
					+ ERR_CHRSEP+ ERR_DESCRIPT_LOC + loException.Message 
			ENDIF
		ENDTRY			 
#ENDIF
		IF USED(m.lcCursor)
			USE IN (m.lcCursor)
		ENDIF
		IF USED(m.lcAlias)
			USE IN (m.lcAlias)
		ENDIF				
		IF SET("Exclusive") # m.lcExclus
			SET EXCLUSIVE &lcExclus
		ENDIF	
		RETURN m.lcRetVal
	ENDFUNC

ENDDEFINE
*//
*// the end of class: testvfp
*////////////////////////////////
