#pragma once

class CComTools
{
public:
	CComTools(void);
	~CComTools(void);
	bool CreateObject(LPCWSTR pszProgID);
	bool CallMethod(LPCWSTR pszMethod, LP_SHORT2ARGVALUE pShort2ArgValue, variant_t& vtReturnValue, bool& bSetTypeResultAttr);
	bool GetErrorInfo(HRESULT& hr, bstr_t& bstrErrMsg, DWORD& dwErrCode);
	void ReleaseAll();
private:
	CComPtr<IUnknown> m_spUnk;
	CComPtr<IDispatch> m_spDisp;
	CComPtr<ITypeInfo> m_spTypeInfo;
	CComPtr<ITypeInfo2> m_spTypeInfo2;
	
	DISPID m_dispid;
	DISPPARAMS m_DispParams;
	EXCEPINFO m_ExceptInfo;
	variant_t m_vtReturnValue;
	UINT m_uArgErr;

	// Win32 error info
	DWORD m_dwErrCode;

	// OLE error info
	HRESULT m_hr;
	bstr_t m_bstrErrMsg;
	
	void clearError();
	void clearDispParams();
	void TypeDescToDWord(const VARTYPE& vtFrom, VARTYPE *pvt, BOOL fIsRval);
};
