#pragma once

#define PATH_PROGID	_T("//DataSet/ComObj/ProgID")
#define PATH_METHOD	_T("//DataSet/ComObj/Method")
#define PATH_PARAMS	_T("//DataSet/ComObj/Params")
#define PATH_COMOBJ	_T("//DataSet/ComObj")

#define VALIDATEONPARS	VARIANT_TRUE

#define XMLPI_ENCODING		L"<?xml version=\"1.0\" encoding=\"utf-8\"?>"
#define XMLPI_STYLESHEET	L"\r\n<?xml-stylesheet type=\"text/xsl\" href=\"Result.xslt\"?>"

class CXmlTools
{
public:
	CXmlTools(void);
	~CXmlTools(void);
protected:
	static TYPEVARIANT m_VariantTypes[];
	
	CComPtr<IXMLDOMDocument> m_spXMLDOMDocument;
	void clearError();
	bool SetErrToDoc();

	inline void AddNode(bstr_t bstrNodeName, CComPtr<IXMLDOMNode>& spPatentNode, CComPtr<IXMLDOMNode>& spNewNode, 
		HRESULT& hr, CComPtr<IXMLDOMNode>& spIDOMNode, VARIANT& vaTypeNodeElement)
	{
		BSTR bstrCurNodeName = bstrNodeName.GetBSTR(); 
		TESTHR(hr = spPatentNode->selectSingleNode(bstrCurNodeName, &spNewNode));
		if (hr == S_FALSE)
		{
			TESTHR(hr = m_spXMLDOMDocument->createNode(vaTypeNodeElement, bstrCurNodeName, 
				L"", &spIDOMNode));
			TESTHR(hr = spPatentNode->appendChild(spIDOMNode, &spNewNode)); 
			spIDOMNode.Release(); 
		}
	}

	inline void AddDS(bstr_t& bstrData, CComPtr<IXMLDOMNode>& spPatentNode, CComPtr<IXMLDOMCDATASection>& spNewDSNode,
		HRESULT& hr, CComPtr<IXMLDOMNode>& spIDOMNode)
	{
		TESTHR(hr = m_spXMLDOMDocument->createCDATASection(bstrData.GetBSTR(), &spNewDSNode));
		if (hr == S_OK)
		{
			TESTHR(hr = spPatentNode->appendChild((CComPtr<IXMLDOMNode>)spNewDSNode, &spIDOMNode)); 
			if (hr == S_OK)
			{
				spIDOMNode.Release(); 
			}
			spNewDSNode.Release(); 
		}
	}

	bstr_t m_bstrProgID;
	bstr_t m_bstrMethod;
	SHORT2ARGVALUE m_mapSHORT2ARGVALUE;


	// Win32 error info
	DWORD m_dwErrCode;

	// OLE error info
	HRESULT m_hr;
	bstr_t m_bstrErrMsg;

	// Error info
	long m_errorCode;
	long m_filePosition;
	long m_lineNumber;
	long m_linePosition;
	bstr_t m_reasonString;
	bstr_t m_sourceString;
	bstr_t m_urlString;

	void ReleaseAll();

public:
	bool loasXML(_bstr_t& bstrXml);
	bool putResult(variant_t vtResult, bool bSetTypeResultAttr);
	bool getDocAsXML(_bstr_t& bstrXml);
	bool putOleError(HRESULT hr, const bstr_t& bstrErrMsg, DWORD dwErrCode);
	inline bstr_t getProgID()
	{
		return m_bstrProgID.copy(); 
	}
	inline bstr_t getMethod()
	{
		return m_bstrMethod.copy(); 
	}
	inline LP_SHORT2ARGVALUE getArgValues()
	{
		return &m_mapSHORT2ARGVALUE; 
	}
	VARTYPE getVariantType(const _bstr_t& bstrType);
	_bstr_t getVariantType(const VARTYPE vt);
};
