// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
// Windows Header Files:
#include <windows.h>
#include <tchar.h>
#include <atlbase.h>
#include <comdef.h>
// TODO: reference additional headers your program requires here
#pragma warning(disable:4786)
#include <map>
using namespace std;

typedef struct _TYPEVARIANT
{
	_bstr_t bstrType;
	VARTYPE vt;
} TYPEVARIANT, *LP_TYPEVARIANT;

typedef struct _ARGVALUE
{
	_bstr_t bstrName;
	_variant_t vtValue;
	VARTYPE vt;
	_ARGVALUE(){};
	_ARGVALUE(_bstr_t pbstrName, _variant_t pvtValue, VARTYPE pvt)
	{
		bstrName = pbstrName.copy();
		vtValue = pvtValue;
		vt = pvt;
	};
} ARGVALUE, *LP_ARGVALUE;

typedef map<SHORT, ARGVALUE, less<SHORT> > SHORT2ARGVALUE, *LP_SHORT2ARGVALUE;

//#define TESTHR(x) if (!SUCCEEDED(x)) _com_issue_error(x);
//inline void TESTHR(HRESULT x) {if (x != S_OK) _com_issue_error(x);};
inline void TESTHR(HRESULT x) {if FAILED(x) _com_issue_error(x);};

#define ERR_UNEXPECTED_FOR_COM 59999
#define ERR_UNEXPECTED_FOR_WIN 59998
#define ERR_UNEXPECTED_FOR_XML 59997

#define LANG_RUS_LOC
#ifndef LANG_RUS_LOC
	#define CMD_START_LOC			_T("Start")
	#define CMD_BREAK_LOC			_T("Terminate")
	#define CMD_EXIT_LOC			_T("Close")
	#define THREAD_DATA_LOC			_T("Hello, thread!")
	#define THREAD_WAITSTARTE_LOC	_T("Waiting start thread...")
	#define THREAD_STARTED_LOC		_T("The thrad is started. Waiting of completion...")
	#define THREADEND_SUCCESS_LOC	_T("The thread was successfully completed!")
	#define THREADEND_TERMINATE_LOC	_T("Thread is terminated.")
	#define THREAD_EXITCODE_LOC		_T("Exit code: ")
	#define	ERR_DLG_CAPTION			_T("Error info")
	#define ERR_UNEXPECTED_LOC		_T("Unexpected error")
	#define ERR_CODE_LOC			_T("Error number: ")
	#define ERR_DESCRIPT_LOC		_T("Description: ")
	#define ERR_METHOD_LOC			_T("Method: ")
	#define ERR_LINE_LOC			_T("Line: ")
	#define ERR_FILEPOS_LOC			_T("File position: ")
	#define ERR_LINEPOS_LOC			_T("Number position : ")
	#define ERR_SOURCE_LOC			_T("Text in file: ")
	#define ERR_URL_LOC				_T("URL: ")
	#define ERR_EXEPT_ARG_LOC		L"Arg #: "
	#define ERR_EXEPT_DES_LOC		L"Description: "
	#define ERR_EXEPT_SRC_LOC		L"Source: "
	#define ERR_EXEPT_HLP_LOC		L"Help file: "
#else
	#define CMD_START_LOC			_T("")
	#define CMD_BREAK_LOC			_T("")
	#define CMD_EXIT_LOC			_T("")
	#define THREAD_DATA_LOC			_T(", !")
	#define THREAD_WAITSTARTE_LOC	_T("  ...")
	#define THREAD_STARTED_LOC		_T(" .  ...")
	#define THREADEND_SUCCESS_LOC	_T("  !")
	#define THREADEND_TERMINATE_LOC	_T(" .")
	#define THREAD_EXITCODE_LOC		_T(" : ")
	#define	ERR_DLG_CAPTION			_T("  ")
	#define ERR_UNEXPECTED_LOC		_T(" ")
	#define ERR_CODE_LOC			_T(" : ")
	#define ERR_DESCRIPT_LOC		_T(": ")
	#define ERR_METHOD_LOC			_T(": ")
	#define ERR_LINE_LOC			_T(": ")
	#define ERR_FILEPOS_LOC			_T("  : ")
	#define ERR_LINEPOS_LOC			_T("  : ")
	#define ERR_SOURCE_LOC			_T("  : ")
	#define ERR_URL_LOC				_T(": ")
	#define ERR_EXEPT_ARG_LOC		L" : "
	#define ERR_EXEPT_DES_LOC		L": "
	#define ERR_EXEPT_SRC_LOC		L": "
	#define ERR_EXEPT_HLP_LOC		L" : "
#endif

