// testThread.cpp : Defines the entry point for the DLL application.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Author:  Michael Drozdov, ICS Soft, Perm, Russia 
// My Page: http://vfpdev.narod.ru/ 
// Date:    10/01/2005
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include "stdafx.h"
#include "XmlTools.h"
#include "ComTools.h"
#include "testThread.h"

typedef map<DWORD, MYTHREADDATA, less<DWORD> > DWORD2MYTHREADDATA;
//typedef pair<DWORD, MYTHREADDATA> Dword_Pair;

///////////////////////////////////
// Public variables
DWORD gCount = 0;							// Count threads
DWORD2MYTHREADDATA gMapDWORD2MYTHREADDATA;	// Threads data storage 

///////////////////////////////////
// Entry into Dll 
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		//CloseThread(TRUE);
		break;
	}
    return TRUE;
}

//////////////////////////////////////////////////////////
// Create and start worker thread
//--------------------------------
// _TCHAR* pszData - user data
// HWND hWnd - window handler (for notify messages)
// UINT nMsg - specifies the message to be sent (for notify messages)
// DWORD* pId - count thread
//--------------------------------
TESTTHREAD_API DWORD CallThread(_TCHAR* pszData, HWND hWnd, UINT nMsg, DWORD* pId)
{
	// Check type of args
	if (pszData == NULL)
	{
		return ERROR_BAD_ARGUMENTS;
	}
	if (hWnd == (HWND)NULL)
	{
		return ERROR_BAD_ARGUMENTS;
	}
	if (nMsg == 0)
	{
		return ERROR_BAD_ARGUMENTS;
	}
	if (pId == 0)
	{
		return ERROR_BAD_ARGUMENTS;
	}

	// Provisionally set error count thread as output parameter
	*pId = (DWORD)(-1); 

	// Get new count thread
	if (++gCount == (DWORD)(-1))
	{
		return ERROR_NOT_ENOUGH_MEMORY;
	}

	// Insert new pair to threads storage
	pair< DWORD2MYTHREADDATA::iterator, bool > pr 
		= gMapDWORD2MYTHREADDATA.insert(DWORD2MYTHREADDATA::value_type(gCount, _MYTHREADDATA()));
	if (!pr.second)
	{
		return ERROR_OUTOFMEMORY;
	}
	// Get reference to current thread storage
	LP_MYTHREADDATA lpThreadData = (LP_MYTHREADDATA)NULL;
	DWORD2MYTHREADDATA::iterator theIterator = pr.first;
	if (theIterator != gMapDWORD2MYTHREADDATA.end())
	{
		lpThreadData = &(*theIterator).second;
	}
	if (lpThreadData == (LP_MYTHREADDATA)NULL)
	{
		return ERROR_OUTOFMEMORY;
	}

	// Save input data to thread storage
	memset((LPVOID)lpThreadData, 0, sizeof(MYTHREADDATA));
	lpThreadData->bstrData = _bstr_t(pszData); 
	lpThreadData->hWnd = hWnd; 
	lpThreadData->nMsg = nMsg;
	
	// CreateThread
	DWORD dwThreadId = 0;
	HANDLE hThread = CreateThread(NULL, 0, ThreadProc, (LPVOID)lpThreadData,
		REAL_SUSPENDED, &dwThreadId);
	if (hThread == (HANDLE)NULL)
	{
		// Error on create thread
		lpThreadData->bstrData = ERROR_OUTPUT_MSG_LOC; 
		return lpThreadData->dwErr = GetLastError(); 
	}

	// Set real new count thread as output parameter
	*pId = gCount; 

	// Save current thread info
	lpThreadData->hThread = hThread;
	lpThreadData->ThreadId = dwThreadId; 

	if (REAL_SUSPENDED != 0)
	{
		// In case suspended thread -> SetThreadPriority & ResumeThread
		if (!SetThreadPriority(hThread, REAL_THREAD_PRIOR))
		{
			lpThreadData->bstrData = ERROR_OUTPUT_MSG_LOC; 
			return lpThreadData->dwErr = GetLastError(); 
		}
		if (ResumeThread(hThread) == (DWORD)(-1))
		{
			lpThreadData->bstrData = ERROR_OUTPUT_MSG_LOC; 
			return lpThreadData->dwErr = GetLastError(); 
		}
	}
	return ERROR_SUCCESS;
}

TESTTHREAD_API BOOL GetThreadData(DWORD Id, _TCHAR* pszData, LONG* pnLenData, 
	DWORD* pdwErr, HRESULT* pHr, _TCHAR* pszComErr, LONG* pnLenComErr)
{
	DWORD2MYTHREADDATA::iterator theIterator = gMapDWORD2MYTHREADDATA.find(Id);
	if (theIterator != gMapDWORD2MYTHREADDATA.end())
	{
		USES_CONVERSION;
		LP_MYTHREADDATA lpThreadData = &(*theIterator).second;
		size_t nSizeData = 0;
		size_t nSizeParam = 0;
		size_t nSizeChar = sizeof(WCHAR);

		// szData
		if (pszData != NULL && pnLenData != NULL)
		{
			LPCWSTR lpwInp = OLE2CW(lpThreadData->bstrData.GetBSTR());
			LPSTR lpsOut = T2A(pszData);
			*pnLenData = (LONG)WideCharToMultiByte(CP_UTF8, 0, 
				lpwInp, (-1), lpsOut, (int)*pnLenData, NULL, NULL);
			/*
			if ((nSizeParam = nSizeChar*wcslen(pszData) + nSizeChar) >= 
				(nSizeData = nSizeChar*lpThreadData->bstrData.length() + nSizeChar))
			{
				wcscpy(pszData, OLE2CW(lpThreadData->bstrData.GetBSTR()));
				if (pnLenData != NULL)
				{
					*pnLenData = (LONG)(nSizeData - nSizeChar);
				}
			}
			else if (nSizeParam - nSizeChar > 0)
			{
				wcsncpy(pszData, OLE2CW(lpThreadData->bstrData.GetBSTR()), (nSizeParam - nSizeChar));
				if (pnLenData != NULL)
				{
					*pnLenData = (LONG)(nSizeParam - nSizeChar);
				}
			}
			else if (pnLenData != NULL)
			{
				*pnLenData = 0L;
			}
			*/
		}
		else if (pnLenData != NULL)
		{
			int cbMultiByte = 0;
			if (lpThreadData->bstrData.length() > 0)
			{
				cbMultiByte = WideCharToMultiByte(CP_UTF8, 0, 
					OLE2CW(lpThreadData->bstrData.GetBSTR()), (-1), NULL, 0, NULL, NULL);
			}
			*pnLenData = (LONG)cbMultiByte;
/*			
			*pnLenData = ((nSizeData = nSizeChar*lpThreadData->bstrData.length()) > 0) ? 
				(LONG)(nSizeData + nSizeChar) : 0L;
*/
		}

		// szComErr
		if (pszComErr != NULL && pnLenComErr != NULL)
		{
			LPCWSTR lpwInp = OLE2CW(lpThreadData->bstrComErr.GetBSTR());
			LPSTR lpsOut = T2A(pszComErr);
			*pnLenComErr = (LONG)WideCharToMultiByte(CP_UTF8, 0, 
				lpwInp, (-1), lpsOut, (int)*pnLenComErr, NULL, NULL);
/*
			if ((nSizeParam = nSizeChar*wcslen(pszComErr) + nSizeChar) >= 
				(nSizeData = nSizeChar*lpThreadData->bstrComErr.length() + nSizeChar))
			{
				wcscpy(pszComErr, OLE2CW(lpThreadData->bstrComErr.GetBSTR()));
				if (pnLenComErr != NULL)
				{
					*pnLenComErr = (LONG)(nSizeData - nSizeChar);
				}
			}
			else if (nSizeParam - nSizeChar > 0)
			{
				wcsncpy(pszComErr, OLE2CW(lpThreadData->bstrComErr.GetBSTR()), (nSizeParam - nSizeChar));
				if (pnLenComErr != NULL)
				{
					*pnLenComErr = (LONG)(nSizeParam - nSizeChar);
				}
			}
			else if (pnLenComErr != NULL)
			{
				*pnLenComErr = 0L;
			}
*/
		}
		else if (pnLenComErr != NULL)
		{
			int cbMultiByte = 0;
			if (lpThreadData->bstrComErr.length() > 0)
			{
				cbMultiByte = WideCharToMultiByte(CP_UTF8, 0, 
					OLE2CW(lpThreadData->bstrComErr.GetBSTR()), (-1), NULL, 0, NULL, NULL);
			}
			*pnLenComErr = (LONG)cbMultiByte;
/*
			*pnLenComErr = ((nSizeData = nSizeChar*lpThreadData->bstrComErr.length()) > 0) ?
				(LONG)(nSizeData + nSizeChar) : 0L;
*/
		}

		// dwErr
		if (pdwErr != NULL)
		{
			*pdwErr = lpThreadData->dwErr; 
		}

		// hr
		if (pHr != NULL)
		{
			*pHr = lpThreadData->hr; 
		}
		return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////
// Terminate or normal close thread
TESTTHREAD_API DWORD CloseThread(DWORD Id, BOOL bTerminate)
{
	DWORD dwRetCode = (DWORD)(-1);
	DWORD2MYTHREADDATA::iterator theIterator = gMapDWORD2MYTHREADDATA.find(Id);
	if (theIterator != gMapDWORD2MYTHREADDATA.end())
	{
		LP_MYTHREADDATA lpThreadData = &(*theIterator).second;
		if (lpThreadData->hThread != (HANDLE)NULL)
		{
			// Is extraordinary exit?
			if (!bTerminate)
			{
				// For not extraordinary exit - wait the completion thread
				WaitForSingleObject(lpThreadData->hThread, INFINITE);
			}
			// Get ExitCode -> dwRetCode
			GetExitCodeThread(lpThreadData->hThread, &dwRetCode);
			if (dwRetCode == STILL_ACTIVE)
			{
				// For extraordinary exit - TerminateThread
				TerminateThread(lpThreadData->hThread, 0);
#ifdef USE_COMTOOLS_REF				
				// Get reference to CComTools object
				CComTools* pComTools = (CComTools*)lpThreadData->pComTools;
				if (pComTools != (CComTools*)NULL)
				{
					pComTools->ReleaseAll();
					pComTools = NULL;
				}
#endif //USE_COMTOOLS_REF				
			}
			// CloseHandle & ReleaseMutex
			CloseHandle(lpThreadData->hThread);
			lpThreadData->hThread = (HANDLE)NULL;
			lpThreadData->ThreadId = 0;
		}
		gMapDWORD2MYTHREADDATA.erase((*theIterator).first); 
	}
	return dwRetCode;
}

////////////////////////////////////////
// Set flag [gbTerminate] for terminate thread
TESTTHREAD_API BOOL BreakThread(DWORD Id)
{
	BOOL bRetVal = FALSE;
	DWORD2MYTHREADDATA::iterator theIterator = gMapDWORD2MYTHREADDATA.find(Id);
	if (theIterator != gMapDWORD2MYTHREADDATA.end())
	{
		LP_MYTHREADDATA lpThreadData = &(*theIterator).second;
		if (lpThreadData->hThread != (HANDLE)NULL)
		{
			EnterCriticalSection(&lpThreadData->cs);
			if (!lpThreadData->bTerminate)
			{
				lpThreadData->bTerminate = TRUE;
			}
			LeaveCriticalSection(&lpThreadData->cs);
			bRetVal = TRUE;
		}
	}
	return bRetVal;
}

//////////////////////////////////////////
// ThreadProc
DWORD WINAPI ThreadProc(LPVOID lpData)
{
	// Check type arg
	LP_MYTHREADDATA lpThreadData = (LP_MYTHREADDATA)lpData;
	if (lpThreadData == (LP_MYTHREADDATA)NULL)
	{
		return ERROR_BAD_ARGUMENTS;
	}
	// COM initialize
	HRESULT hr = CoInitialize(NULL);
	if (!SUCCEEDED(hr))
	{
		lpThreadData->hr = hr; 
		_com_error com_err(hr);
		lpThreadData->bstrComErr = com_err.ErrorMessage();
		lpThreadData->bstrData = ERROR_OUTPUT_MSG_LOC;
		return lpThreadData->dwErr = ERR_UNEXPECTED_FOR_WIN;
	}
	InitializeCriticalSection(&lpThreadData->cs);

	// Notify about start thread
	BOOL bIsMsgHandler = lpThreadData->hWnd && lpThreadData->nMsg;
	if (bIsMsgHandler)
	{
		// Send ThreadId to client!
		PostMessage(lpThreadData->hWnd, lpThreadData->nMsg, 2, lpThreadData->ThreadId);
		Sleep(SLEEP_TIME);
	}

	// Set dwRetCode as 'successfully completed'
	DWORD dwRetCode = (DWORD)(-1);
	CXmlTools xmlTools;
	bool bIsXmlData = false;
	USES_CONVERSION;

	try
	{
		// Test XML-data format
		_TCHAR* lpTest = _tcsstr(OLE2CT(lpThreadData->bstrData.GetBSTR()), PART_XML_HEAD);
		if (lpTest != NULL)
		{
			////////////////////////////////////
			// XML-data format
			// Load xml-data... get ProgID, Method, Parameters
			if (bIsXmlData = xmlTools.loasXML(lpThreadData->bstrData))
			{
				bool bIsComErr = true;
				CComTools comTools;
#ifdef USE_COMTOOLS_REF				
				// Set reference to CComTools object
				lpThreadData->pComTools = (LPVOID)&comTools;
#endif //USE_COMTOOLS_REF				

				// Create COM-object
				if (comTools.CreateObject(OLE2CW(xmlTools.getProgID().GetBSTR())))
				{
					variant_t vtRetValue;
					VariantInit(&vtRetValue.GetVARIANT());
					bool bSetTypeResultAttr = false;
					// Call method
					if (comTools.CallMethod(OLE2CW(xmlTools.getMethod().GetBSTR()), xmlTools.getArgValues(), vtRetValue, bSetTypeResultAttr))
					{
						// Save result
						bIsComErr = false;
						xmlTools.putResult(vtRetValue, bSetTypeResultAttr);
					}
					VariantClear(&vtRetValue.GetVARIANT());
				}
				// Check error
				if (bIsComErr)
				{
					EnterCriticalSection(&lpThreadData->cs);
					if (comTools.GetErrorInfo(lpThreadData->hr, lpThreadData->bstrComErr, lpThreadData->dwErr))
					{
						xmlTools.putOleError(lpThreadData->hr, lpThreadData->bstrComErr, lpThreadData->dwErr);
					}
					// Set error to dwRetCode
					if (lpThreadData->dwErr == ERROR_SUCCESS)
					{
						lpThreadData->dwErr = ERR_UNEXPECTED_FOR_WIN;
					}
					dwRetCode = lpThreadData->dwErr; 
					LeaveCriticalSection(&lpThreadData->cs);
				}
			}
		}
		else
		{
			_com_issue_error(E_INVALIDARG); //E_UNEXPECTED
/*			
			_TCHAR* lpTest = (_TCHAR*)OLE2CT(lpThreadData->bstrData.GetBSTR());
			if (lpTest != NULL)
			{

				////////////////////////////////////
				// Not XML-data
				////////////////////////////////////
				// For test errors only:
				//---------------------------------
				//_com_issue_error(E_OUTOFMEMORY);
				//SetLastError(ERROR_RESOURCE_DISABLED); throw(ERROR_RESOURCE_DISABLED); 
				//---------------------------------
				////////////////////////////////////
				
				////////////////////////////////////
				// Do some works
				DWORD dwStartTC = GetTickCount();
				BOOL bIsTerminate = FALSE;
				do
				{
					Sleep(SLEEP_TIME);
					EnterCriticalSection(&lpThreadData->cs);
					bIsTerminate = lpThreadData->bTerminate;
					LeaveCriticalSection(&lpThreadData->cs);
				} 
				while((GetTickCount() - dwStartTC) <  THREAD_TIMEOUT && !bIsTerminate);
			}
			else
			{
				_com_issue_error(E_INVALIDARG); //E_UNEXPECTED
			}
*/
		}
	}
	catch(_com_error& e)
	{
		// COM error
		EnterCriticalSection(&lpThreadData->cs);
		lpThreadData->hr = e.Error();
		lpThreadData->bstrComErr = e.ErrorMessage();   
		if (dwRetCode == (DWORD)(-1))
		{
			dwRetCode = lpThreadData->dwErr = ERR_UNEXPECTED_FOR_COM;
		}
		lpThreadData->bTerminate = TRUE; 
		if (bIsXmlData)
		{
			xmlTools.putOleError(lpThreadData->hr, lpThreadData->bstrComErr, lpThreadData->dwErr);
		}
		LeaveCriticalSection(&lpThreadData->cs);
	}
	catch(...)
	{
		// Any other errors
		EnterCriticalSection(&lpThreadData->cs);
		DWORD dwCD = GetLastError();
		if (dwCD == ERROR_SUCCESS)
		{
			dwCD = ERR_UNEXPECTED_FOR_WIN;
		}
		dwRetCode = lpThreadData->dwErr = dwCD; 
		lpThreadData->bTerminate = TRUE; 
		if (bIsXmlData)
		{
			xmlTools.putOleError(lpThreadData->hr, lpThreadData->bstrComErr, lpThreadData->dwErr);
		}
		LeaveCriticalSection(&lpThreadData->cs);
	}

	// Save result...
	EnterCriticalSection(&lpThreadData->cs);
	if (!bIsXmlData)
	{
		// No XML-data
		if (dwRetCode == (DWORD)(-1))
		{
			// Set result in case: 'successfully completed' or 'terminate by user'
			lpThreadData->bstrData = lpThreadData->bTerminate ? TERMINATE_OUTPUT_MSG_LOC : SUCCESSE_OUTPUT_MSG_LOC;
		}
		else
		{
			// Set result in case error
			lpThreadData->bstrData = ERROR_OUTPUT_MSG_LOC;
		}
	}
	else
	{
		// In case XML-data
		xmlTools.getDocAsXML(lpThreadData->bstrData);
	}

	// ... and notify about the end of thread
	if (bIsMsgHandler)
	{
		PostMessage(lpThreadData->hWnd, lpThreadData->nMsg, lpThreadData->bTerminate ? 1 : 0 , 0);
	}
	LeaveCriticalSection(&lpThreadData->cs);
	
	Sleep(SLEEP_TIME);

	DeleteCriticalSection(&lpThreadData->cs);

	// COM uninitialize
	CoUninitialize();
	return dwRetCode;
}

//#pragma warning(default:4786)
