// testThread.h
//
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the TESTTHREAD_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// TESTTHREAD_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Author:  Michael Drozdov, ICS Soft, Perm, Russia 
// My Page: http://vfpdev.narod.ru/ 
// Date:    10/01/2005
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#pragma once

#define TESTTHREAD_API __declspec(dllexport)

#define LANG_RUS_LOC
#ifndef LANG_RUS_LOC
	#define SUCCESSE_OUTPUT_MSG_LOC		_T("The thread was successfully completed!")
	#define TERMINATE_OUTPUT_MSG_LOC	_T("Thread is terminated.")
	#define ERROR_OUTPUT_MSG_LOC		_T("Thread on error terminated.")
#else
	#define SUCCESSE_OUTPUT_MSG_LOC		_T("   !")
	#define TERMINATE_OUTPUT_MSG_LOC	_T("   .")
	#define ERROR_OUTPUT_MSG_LOC		_T("    - .")
#endif

#define MUTEX_NAME			_T("8277EA0D-AD90-4598-8964-FBAFB47C7BE9")	
#define MUTEX_TIMEOUT		30000
#define THREAD_TIMEOUT		20000
#define REAL_SUSPENDED		CREATE_SUSPENDED // 0
#define REAL_THREAD_PRIOR	THREAD_PRIORITY_IDLE
#define SLEEP_TIME			0

#define ERR_UNEXPECTED_FOR_COM 59999
#define ERR_UNEXPECTED_FOR_WIN 59998

#define PART_XML_HEAD	_T("<?xml")

// USE_COMTOOLS_REF
#define USE_COMTOOLS_REF
#undef  USE_COMTOOLS_REF

typedef struct _MYTHREADDATA
{
	_bstr_t bstrData;
	HWND hWnd;
	UINT nMsg;
	DWORD dwErr;
	HRESULT hr;
	_bstr_t bstrComErr;
	HANDLE hThread;
	BOOL bTerminate;
	DWORD ThreadId;
	CRITICAL_SECTION cs;
#ifdef USE_COMTOOLS_REF				
	LPVOID pComTools;
#endif //USE_COMTOOLS_REF				
	_MYTHREADDATA(){};
} MYTHREADDATA, *LP_MYTHREADDATA;

extern TESTTHREAD_API DWORD CallThread(_TCHAR* pszData, HWND hWnd, UINT nMsg, DWORD* pId);
extern TESTTHREAD_API DWORD CloseThread(DWORD Id, BOOL bTerminate);
extern TESTTHREAD_API BOOL BreakThread(DWORD Id);
extern TESTTHREAD_API BOOL GetThreadData(DWORD Id,_TCHAR* pszData, LONG* pnLenData, 
	DWORD* pdwErr, HRESULT* pHr, _TCHAR* pszComErr, LONG* pnLenComErr);

DWORD WINAPI ThreadProc(LPVOID lpData);

